Subject: Re: [PATCH RFC net-next] net: Poptrie based routing table lookup

From: Jesper Dangaard Brouer <[email-masked]>
Date: Wed, 5 Sep 2018 07:54:23 +0200

On Tue, 4 Sep 2018 16:34:36 -0400
"Md. Islam" <[email-masked]> wrote:

> On Tue, Sep 4, 2018 at 12:14 PM, Md. Islam <[email-masked]> wrote:
> >
> > On Tue, Sep 4, 2018, 6:53 AM Jesper Dangaard Brouer <[email-masked]>
> > wrote:  
> >>
> >> Hi Md. Islam,
> >>
> >> People will start to ignore you, when you don't interact appropriately
> >> with the community, and you ignore their advice, especially when it is
> >> about how to interact with the community[1].
> >>
> >> You have not addressed any of my feedback on your patch in [1].
> >>  [1]
> >> http://www.mail-archive.com/search?l=mid&q=[email-masked]  
> >
> >
> > Jesper,
> >
> > I actually addressed all the feedbacks in the previous patch except TOS,
> > FIB_matrics, and etc. This is because I don't think they are relevant in
> > this usecase. Please let me know if I wrong.
> >
> > Thanks  
> 
> Jesper
> 
> Sorry, I missed your review in the first place. I will take a look and
> resubmit the patch.

Good that you actually noticed yourself, that you did not address any
of my feedback.  I don't want to repeat myself, so you just need to
follow the above link, and the link below (coding style +checkpatch.pl).

> >>
> >>
> >>
> >> --
> >> Best regards,
> >>   Jesper Dangaard Brouer
> >>   MSc.CS, Principal Kernel Engineer at Red Hat
> >>   LinkedIn: http://www.linkedin.com/in/brouer
> >>
> >> p.s. also top-posting is bad, but I suspect you will not read my
> >> response if I don't top-post.
> >>
> >>
> >> On Tue, 4 Sep 2018 01:02:30 -0400 "Md. Islam" <[email-masked]> wrote:
> >>  
> >> > This patch implements Poptrie based routing table
> >> > lookup/insert/delete/flush. Currently many carrier routers use kernel
> >> > bypass frameworks such as DPDK and VPP to implement the data plane.
> >> > XDP along with this patch will enable Linux to work as such a router.
> >> > Currently it supports up to 255 ports. Many real word backbone routers
> >> > have up to 233 ports (to the best of my knowledge), so it seems to be
> >> > sufficient at this moment.
> >> >
> >> > I also have attached a draft paper to explain it works (poptrie.pdf).
> >> > Please set CONFIG_FIB_POPTRIE=y (default n) before testing the patch.
> >> > Note that, poptrie_lookup() is not being called from anywhere. It will
> >> > be used by XDP forwarding.
> >> >
> >> >
> >> > From 3dc9683298ed896dd3080733503c35d68f05370e Mon Sep 17 00:00:00 2001
> >> > From: tamimcse <[email-masked]>
> >> > Date: Mon, 3 Sep 2018 23:56:43 -0400
> >> > Subject: [PATCH] Poptrie based routing table lookup
> >> >
> >> > Signed-off-by: tamimcse <[email-masked]>
> >> > ---
> >> >  include/net/ip_fib.h   |  42 +++++
> >> >  net/ipv4/Kconfig       |   4 +
> >> >  net/ipv4/Makefile      |   1 +
> >> >  net/ipv4/fib_poptrie.c | 483
> >> > +++++++++++++++++++++++++++++++++++++++++++++++++
> >> >  net/ipv4/fib_trie.c    |  12 ++
> >> >  5 files changed, 542 insertions(+)
> >> >  create mode 100644 net/ipv4/fib_poptrie.c  
> >>
> >> First of order of business: You need to conform to the kernels coding
> >> standards!
> >>
> >> https://www.kernel.org/doc/html/v4.18/process/coding-style.html
> >>
> >> There is a script avail to check this called: scripts/checkpatch.pl
> >> It summary says:
> >>  total: 139 errors, 238 warnings, 6 checks, 372 lines checked
> >> (Not good, more error+warnings than lines...)
> >>
> >> Please fix up those... else people will not even read you code!